//
//	HSP3 OpenGL graphics command
//	(GUI֘AR}hE֐)
//
#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <nds.h>
#include <nds/registers_alt.h>
#include <nds/videoGL.h>

#include "as_lib9.h"
#include "hsp3config.h"
#include "hsp3code.h"
#include "hsp3debug.h"
#include "supio.h"
#include "strbuf.h"

#include "hsp3nds.h"
#include "hsp3gr_nds.h"
#include "nds_console.h"
#include "dpmread.h"

/*------------------------------------------------------------*/
/*
		system data
*/
/*------------------------------------------------------------*/
static HSPCTX *ctx;
static int *type;
static int *val;


/*------------------------------------------------------------*/
/*
		interface
*/
/*------------------------------------------------------------*/

static int cmdfunc_glcmd( int cmd )
{
  //		cmdfunc : TYPE_EXTCMD
  //		(GUIR}h)
  //
  code_next();							// ̃R[h擾(ŏɕKKvł)
  switch( cmd ) {							// TuR}hƂ̕
    
  case 0://glMaterial3b
    {
      GL_MATERIALS_ENUM mode = (GL_MATERIALS_ENUM)code_getdi( 0 );
      int r = code_getdi( 0 );
      int g = code_getdi( 0 );
      int b = code_getdi( 0 );
      glMaterialf( mode, RGB15( r, g, b ) );
      break;
    }
  case 1://glBegin
    {
      GL_GLBEGIN_ENUM mode = (GL_GLBEGIN_ENUM)code_getdi( 0 );
      glBegin( mode );
      break;
    }
  case 2://glEnd
    {
      glEnd();
      break;
    }
  case 3://glClearDepth
    {
      fixed12d3 depth = float_to_12d3((float)code_getdd( 0 ));
      //glClearDepth( depth );
      glClearDepth(0x7FFF);
      break;
    }
  case 4://glPushMatrix
    {
      glPushMatrix();
      break;
    }
  case 5://glPopMatrix
    {
      int32 num = code_getdi( 0 );
      glPopMatrix( num );
      break;
    }
  case 6://glRestoreMatrix
    {
      int32 index = code_getdi( 0 );
      glRestoreMatrix( index );
      break;
    }
  case 7://glStoreMatrix
    {
      int32 index = code_getdi( 0 );
      glStoreMatrix( index );
      break;
    }
  case 8://glLight
    {
      int id = code_getdi( 0 );
      int r = code_getdi( 0 );
      int g = code_getdi( 0 );
      int b = code_getdi( 0 );
      float x = (float)code_getdd( 0 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glLight( id, RGB15( r, g, b ), floattov10(x), floattov10(y), floattov10(z) );
      break;
    }
  case 10://glLoadIdentity
    {
      glLoadIdentity();
      break;
    }
  case 11://glMatrixMode
    {
      GL_MATRIX_MODE_ENUM mode = (GL_MATRIX_MODE_ENUM)code_getdi( 0 );
      glMatrixMode( mode );
      break;
    }
  case 12://glViewport
    {
      uint8 x1 = code_getdi( 0 );
      uint8 y1 = code_getdi( 0 );
      uint8 x2 = code_getdi( 0 );
      uint8 y2 = code_getdi( 0 );
      glViewport( x1, y1, x2, y2 );
      break;
    }
  case 13://glFlush
    {
      uint32 mode = code_getdi( 0 );
      glFlush( mode );
      break;
    }
  case 14://glMaterialShinyness
    {
      glMaterialShinyness();
      break;
    }
  case 15://glPolyFmt
    {
      uint32 params = code_getdi( 0 );
      glPolyFmt( params );
      break;
    }
  case 16://glEnable
    {
      int bits = code_getdi( 0 );
      glEnable( bits );
      break;
    }
  case 17://glDisable
    {
      int bits = code_getdi( 0 );
      glDisable( bits );
      break;
    }
  case 18://glLoadMatrix4x4
    {
      m4x4 m;
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 16; i++)
	m.m[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glLoadMatrix4x4( &m );
      break;
    }
  case 19://glLoadMatrix4x3
    {
      m4x3 m;
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 12; i++)
	m.m[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glLoadMatrix4x3( &m );
      break;
    }
  case 20://glMultMatrix4x4
    {
      m4x4 m;
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 16; i++)
	m.m[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glMultMatrix4x4( &m );
      break;
    }
  case 21://glMultMatrix4x3
    {
      m4x3 m;
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 12; i++)
	m.m[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glMultMatrix4x3( &m );
      break;
    }
  case 22://glMultMatrix3x3
    {
      m3x3 m;
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 9; i++)
	m.m[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glMultMatrix3x3( &m );
      break;
    }
  case 23://gluPickMatrix
    {
      int x = code_getdi( 0 );
      int y = code_getdi( 0 );
      int width= code_getdi( 3 );
      int height= code_getdi( 3 );
      int viewport[4];
      viewport[0] = code_getdi( 0 );
      viewport[1] = code_getdi( 0 );
      viewport[2] = code_getdi( 255 );
      viewport[3] = code_getdi( 191 );
      gluPickMatrix( x, y, width, height, viewport );
      break;
    }
  case 24://glResetMatrixStack
    {
      glResetMatrixStack();
      break;
    }
  case 25://glSetOutlineColor
    {
      int id = code_getdi( 0 );
      int r = code_getdi( 0 );
      int g = code_getdi( 0 );
      int b = code_getdi( 0 );
      glSetOutlineColor( id, RGB15( r, g, b ) );
      break;
    }
  case 26://glSetToonTable
    {
      uint16 table[32];
      PVal *pval;
      pval = code_getpval();
      for (int i = 0; i < 32; i++)
	table[i] = *(int*)HspVarCoreArrayElementPtr( pval, i );
      glSetToonTable( table );
      break;
    }
  case 27://glSetToonTableRange
    {
      int start = code_getdi( 0 );
      int end = code_getdi( 0 );
      int r = code_getdi( 0 );
      int g = code_getdi( 0 );
      int b = code_getdi( 0 );
      glSetToonTableRange( start, end, RGB15( r, g, b ) );
      break;
    }
  case 28://glAlphaFunc
    {
      int alphaThreshold = code_getdi( 0 );
      glAlphaFunc( alphaThreshold );
      break;
    }
  case 29://glCutoffDepth
    {
      fixed12d3 wVal = float_to_12d3((float)code_getdd( 0 ));
      glCutoffDepth( wVal );
      break;
    }
  case 30://glInit
    {
      //videoSetMode(MODE_0_3D);
      //videoSetMode(MODE_0_3D | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);
      //videoSetMode(MODE_0_3D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE);
      videoSetMode(MODE_0_3D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);
      glInit();
      break;
    }
  case 31://glClearColor
    {
      uint8 red = code_getdi( 0 );
      uint8 green = code_getdi( 0 );
      uint8 blue = code_getdi( 0 );
      uint8 alpha = code_getdi( 0 );
      glClearColor( red, green, blue, alpha );
      break;
    }
  case 32://glClearPolyID
    {
      uint8 ID = code_getdi( 0 );
      glClearPolyID( ID );
      break;
    }
  case 33://glVertex3f
    {
      float x = (float)code_getdd( 0 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glVertex3f( x, y, z );
      break;
    }
  case 34://glRotatef
    {
      float angle = (float)code_getdd( 0 );
      float x = (float)code_getdd( 1 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glRotatef( angle, x, y, z );
      break;
    }
  case 35://glColor3f
    {
      float r = (float)code_getdd( 0 );
      float g = (float)code_getdd( 0 );
      float b = (float)code_getdd( 0 );
      glColor3f( r, g, b );
      break;
    }
  case 36://glScalef
    {
      float x = (float)code_getdd( 0 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glScalef( x, y, z );
      break;
    }
  case 37://glTranslatef
    {
      float x = (float)code_getdd( 0 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glTranslatef( x, y, z );
      break;
    }
  case 38://glNormal3f
    {
      float x = (float)code_getdd( 0 );
      float y = (float)code_getdd( 0 );
      float z = (float)code_getdd( 0 );
      glNormal3f( x, y, z );
      break;
    }
  case 39://glRotateX
    {
      float angle = (float)code_getdd( 0 );
      glRotateX( angle );
      break;
    }
  case 40://glRotateY
    {
      float angle = (float)code_getdd( 0 );
      glRotateY( angle );
      break;
    }
  case 41://glRotateZ
    {
      float angle = (float)code_getdd( 0 );
      glRotateZ( angle );
      break;
    }
  case 42://glOrtho
    {
      float left = (float)code_getdd( 0 );
      float right = (float)code_getdd( 0 );
      float bottom = (float)code_getdd( 0 );
      float top = (float)code_getdd( 0 );
      float zNear = (float)code_getdd( 0 );
      float zFar = (float)code_getdd( 0 );
      glOrtho( left, right, bottom, top, zNear, zFar );
      break;
    }
  case 43://gluLookAt
    {
      double eyex = code_getd();
      double eyey = code_getd();
      double eyez = code_getd();
      double lookAtx = code_getd();
      double lookAty = code_getd();
      double lookAtz = code_getd();
      double upx = code_getd();
      double upy = code_getd();
      double upz = code_getd();
      gluLookAt( eyex, eyey, eyez, lookAtx, lookAty, lookAtz, upx, upy, upz );
      /*
      printf("lookat %f %f %f %f %f %f %f %f %f\n",
	     (double)eyex, (double)eyey, (double)eyez,
	     (double)lookAtx, (double)lookAty, (double)lookAtz,
	     (double)upx, (double)upy, (double)upz);
      printf("lookat %d %d %d %d %d %d %d %d %d\n",
	     (int)eyex, (int)eyey, (int)eyez,
	     (int)lookAtx, (int)lookAty, (int)lookAtz,
	     (int)upx, (int)upy, (int)upz);
      */
      break;
    }
  case 44://glFrustum
    {
      float left = (float)code_getd();
      float right = (float)code_getd();
      float bottom = (float)code_getd();
      float top = (float)code_getd();
      float near = (float)code_getd();
      float far = (float)code_getd();
      glFrustum( left, right, bottom, top, near, far );
      break;
    }
  case 45://gluPerspective
    {
      float fovy = (float)code_getd();
      float aspect = (float)code_getd();
      float zNear = (float)code_getd();
      float zFar = (float)code_getd();
      gluPerspective( fovy, aspect, zNear, zFar );
      /*
      printf("gluPerspective %f %f %f %f\n",
	     (double)fovy, (double)aspect,
	     (double)zNear, (double)zFar);
      */
      break;
    }
    /*
  case 0x02:								// exec
    {
      char *ps;
      char fname[HSP_MAX_PATH];
      strncpy( fname, code_gets(), HSP_MAX_PATH-1 );
      p1 = code_getdi( 0 );
      ps = code_getds( "" );
      //ExecFile( fname, ps, p1 );
      break;
    }
    
    
  case 0x86:								// ndsMp3Loop
    {
      p1 = code_getdi( 0 );
      AS_SetMP3Loop(p1);
		break;
    }
    */
  default:
    throw HSPERR_UNSUPPORTED_FUNCTION;
  }
  return RUNMODE_RUN;
}


static int reffunc_intfunc_ivalue;

static void *reffunc_function( int *type_res, int arg )
{
	void *ptr;

	//		Ԓl̃^Cvݒ肷
	//
	*type_res = HSPVAR_FLAG_INT;			// Ԓl̃^Cvw肷
	ptr = &reffunc_intfunc_ivalue;			// Ԓl̃|C^

	//			'('Ŏn܂邩𒲂ׂ
	//
	if ( *type != TYPE_MARK ) throw HSPERR_INVALID_FUNCPARAM;
	if ( *val != '(' ) throw HSPERR_INVALID_FUNCPARAM;
	code_next();

	switch( arg & 0xff ) {

	//	int function
	default:
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}

	//			'('ŏI邩𒲂ׂ
	//
	if ( *type != TYPE_MARK ) throw HSPERR_INVALID_FUNCPARAM;
	if ( *val != ')' ) throw HSPERR_INVALID_FUNCPARAM;
	code_next();

	return ptr;
}


static int termfunc_glcmd( int option )
{
	//		termfunc : TYPE_EXTCMD
	//		(GUI)
	//
	return 0;
}

void hsp3typeinit_cl_glcmd( HSP3TYPEINFO *info )
{
	HSPEXINFO *exinfo;								// Info for Plugins
	int i;

	ctx = info->hspctx;
	exinfo = info->hspexinfo;
	type = exinfo->nptype;
	val = exinfo->npval;

	//		function register
	//
	info->cmdfunc = cmdfunc_glcmd;
	info->termfunc = termfunc_glcmd;

}

void hsp3typeinit_cl_glfunc( HSP3TYPEINFO *info )
{
	info->reffunc = reffunc_function;
}

