;
; OpenHSP for NDS
;
#ifndef __ndsGL__
#define __ndsGL__

#define global GL_FALSE     0
#define global GL_TRUE      1

#define global GL_TRIANGLES      0
#define global GL_QUADS          1
#define global GL_TRIANGLE_STRIP 2
#define global GL_QUAD_STRIP     3
#define global GL_TRIANGLE       0
#define global GL_QUAD           1

#define global GL_PROJECTION     0
#define global GL_POSITION       1
#define global GL_MODELVIEW      2
#define global GL_TEXTURE        3

#define global GL_AMBIENT             0x01
#define global GL_DIFFUSE             0x02
#define global GL_AMBIENT_AND_DIFFUSE 0x03
#define global GL_SPECULAR            0x04
#define global GL_SHININESS           0x08
#define global GL_EMISSION            0x10

#define global POLY_FORMAT_LIGHT0   (1<<0)
#define global POLY_FORMAT_LIGHT1   (1<<1)
#define global POLY_FORMAT_LIGHT2   (1<<2)
#define global POLY_FORMAT_LIGHT3   (1<<3)
#define global POLY_MODULATION      (0<<4)
#define global POLY_DECAL           (1<<4)
#define global POLY_TOON_HIGHLIGHT  (2<<4)
#define global POLY_SHADOW          (3<<4)
#define global POLY_CULL_FRONT      (1<<6)
#define global POLY_CULL_BACK       (2<<6)
#define global POLY_CULL_NONE       (3<<6)
#define global POLY_FOG             (1<<15)

#define global TEXTURE_SIZE_8    0
#define global TEXTURE_SIZE_16   1
#define global TEXTURE_SIZE_32   2
#define global TEXTURE_SIZE_64   3
#define global TEXTURE_SIZE_128  4
#define global TEXTURE_SIZE_256  5
#define global TEXTURE_SIZE_512  6
#define global TEXTURE_SIZE_1024 7

#define global GL_TEXTURE_WRAP_S (1 << 16)
#define global GL_TEXTURE_WRAP_T (1 << 17)
#define global GL_TEXTURE_FLIP_S (1 << 18)
#define global GL_TEXTURE_FLIP_T (1 << 19)
#define global GL_TEXTURE_COLOR0_TRANSPARENT (1<<29)
#define global TEXGEN_OFF      (0<<30)
#define global TEXGEN_TEXCOORD (1<<30)
#define global TEXGEN_NORMAL   (2<<30)
#define global TEXGEN_POSITION (3<<30)

#define global GL_RGB32_A3   1
#define global GL_RGB4       2
#define global GL_RGB16      3
#define global GL_RGB256     4
#define global GL_COMPRESSED 5
#define global GL_RGB8_A5    6
#define global GL_RGBA       7
#define global GL_RGB        8

#define global GL_TEXTURE_2D      (1<<0)
#define global GL_TOON_HIGHLIGHT  (1<<1)
#define global GL_ALPHA_TEST      (1<<2)
#define global GL_BLEND           (1<<3)
#define global GL_ANTIALIAS       (1<<4)
#define global GL_OUTLINE         (1<<5)
#define global GL_FOG_ONLY_ALPHA  (1<<6)
#define global GL_FOG             (1<<7)
#define global GL_COLOR_UNDERFLOW (1<<12
#define global GL_POLY_OVERFLOW   (1<<13)
#define global GL_CLEAR_BMP       (1<<14)

#define global GL_GET_VERTEX_RAM_COUNT	0
#define global GL_GET_POLYGON_RAM_COUNT	1
#define global GL_GET_MATRIX_VECTOR	2
#define global GL_GET_MATRIX_POSITION	3
#define global GL_GET_MATRIX_PROJECTION	4
#define global GL_GET_MATRIX_CLIP	5
#define global GL_GET_TEXTURE_WIDTH	6
#define global GL_GET_TEXTURE_HEIGHT	7

#define global GL_TRANS_MANUALSORT (1<<0)
#define global GL_WBUFFERING       (1<<1)

#regcmd 18

;void glMaterial3b(GL_MATERIALS_ENUM mode, uint8 red, uint8 green, uint8 blue)
#cmd glMaterial3b		0
;void glBegin(GL_GLBEGIN_ENUM mode)
#cmd glBegin		1
;void glEnd(void)
#cmd glEnd		2
;void glClearDepthf(float depth)
#cmd glClearDepthf		3
;void glPushMatrix(void)
#cmd glPushMatrix		4
;void glPopMatrix(int32 num)
#cmd glPopMatrix		5
;void glRestoreMatrix(int32 index)
#cmd glRestoreMatrix		6
;void glStoreMatrix(int32 index)
#cmd glStoreMatrix		7
;void glLight(int id, uint8 red, uint8 green, uint8 blue, float x, float y, float z)
#cmd glLight		8
;void glLoadIdentity(void)
#cmd glLoadIdentity		10
;void glMatrixMode(GL_MATRIX_MODE_ENUM mode)
#cmd glMatrixMode		11
;void glViewport(uint8 x1, uint8 y1, uint8 x2, uint8 y2)
#cmd glViewport		12
;void glFlush(uint32 mode)
#cmd glFlush		13
;void glMaterialShinyness(void)
#cmd glMaterialShinyness		14
;void glPolyFmt(uint32 params)
#cmd glPolyFmt		15
;void glEnable(int bits)
#cmd glEnable		16
;void glDisable(int bits)
#cmd glDisable		17
;void glLoadMatrix4x4(const m4x4 *m)
#cmd glLoadMatrix4x4		18
;void glLoadMatrix4x3(const m4x3 * m)
#cmd glLoadMatrix4x3		19
;void glMultMatrix4x4(const m4x4 * m)
#cmd glMultMatrix4x4		20
;void glMultMatrix4x3(const m4x3 * m)
#cmd glMultMatrix4x3		21
;void glMultMatrix3x3(const m3x3 * m)
#cmd glMultMatrix3x3		22
;void gluPickMatrix(int x, int y, int width, int height, int vx0, , int vy0, int vx1, int vy1)
#cmd gluPickMatrix		23
;void glResetMatrixStack(void)
#cmd glResetMatrixStack		24
;void glSetOutlineColor(int id, uint8 red, uint8 green, uint8 blue)
#cmd glSetOutlineColor		25
;void glSetToonTable(const uint16 table[32])
#cmd glSetToonTable		26
;void glSetToonTableRange(int start, int end, uint8 red, uint8 green, uint8 blue)
#cmd glSetToonTableRange		27
;void glAlphaFunc(int alphaThreshold)
#cmd glAlphaFunc		28
;void glCutoffDepth(float wVal)
#cmd glCutoffDepth		29
;void glInit()
#cmd glInit		30
;void glClearColor(uint8 red, uint8 green, uint8 blue, uint8 alpha)
#cmd glClearColor		31
;void glClearPolyID(uint8 ID)
#cmd glClearPolyID		32
;void glVertex3f(float x, float y, float z)
#cmd glVertex3f		33
;void glRotatef32(float angle, int32 x, int32 y, int32 z)
#cmd glRotatef		34
;void glColor3f(float r, float g, float b)
#cmd glColor3f		35
;void glScalef(float x, float y, float z)
#cmd glScalef		36
;void glTranslatef(float x, float y, float z)
#cmd glTranslatef		37
;void glNormal3f(float x, float y, float z)
#cmd glNormal3f		38
;void glRotateX(float angle)
#cmd glRotateX		39
;void glRotateY(float angle)
#cmd glRotateY		40
;void glRotateZ(float angle)
#cmd glRotateZ		41
;void glOrtho(float left, float right, float bottom, float top, float zNear, float zFar)
#cmd glOrtho		42
;void gluLookAt(	float eyex, float eyey, float eyez, float lookAtx, float lookAty, float lookAtz, float upx, float upy, float upz)
#cmd gluLookAt		43
;void glFrustum(float left, float right, float bottom, float top, float near, float far)
#cmd glFrustum		44
;void gluPerspective(float fovy, float aspect, float zNear, float zFar)
#cmd gluPerspective		45
;void glTexCoord2f(float s, float t)
#cmd glTexCoord2f		46

/*
int glTexImage2D(int target, int empty1, GL_TEXTURE_TYPE_ENUM type, int sizeX, int sizeY, int empty2, int param, const uint8* texture);
void glTexLoadPal(const u16* pal, u16 count, u32 addr );
int gluTexLoadPal(const u16* pal, u16 count, uint8 format);
void glTexParameter(	uint8 sizeX, uint8 sizeY, const uint32* addr, GL_TEXTURE_TYPE_ENUM mode, uint32 param) ;
u32 glGetTexParameter();
void* glGetTexturePointer(int name);
void glBindTexture(int target, int name);
void glColorTable(uint8 format, uint32 addr);
int glGenTextures(int n, int *names);
void glResetTextures(void);
void glTexCoord2f32(int32 u, int32 v);



void glInit_C(void);
gl_hidden_globals* glGetGlobals();
uint32 POLY_ALPHA(int n)
uint32 POLY_ID(int n)

void glColor3b(uint8 red, uint8 green, uint8 blue)
void glColor(rgb color)

void glVertex3v16(v16 x, v16 y, v16 z)
void glTexCoord2t16(t16 u, t16 v)

void glScalev(const GLvector* v)
void glScalef32(int32 factor)

void glTranslatev(const GLvector* v)
void glTranslate3f32(int32 x, int32 y, int32 z)

void glCallList(const u32* list)

void glRotateXi(int angle)// (angle is 0-511)
void glRotateYi(int angle)
void glRotateZi(int angle)

void glOrthof32(int32 left, int32 right, int32 bottom, int32 top, int32 zNear, int32 zFar)
void gluLookAtf32(int32 eyex, int32 eyey, int32 eyez, int32 lookAtx, int32 lookAty, int32 lookAtz, int32 upx, int32 upy, int32 upz)
void glFrustumf32(int32 left, int32 right, int32 bottom, int32 top, int32 near, int32 far)
void gluPerspectivef32(int fovy, int32 aspect, int32 zNear, int32 zFar)

void glGetFixed(const GL_GET_ENUM param, int32* f)
void glGetInt(GL_GET_ENUM param, int* i)

void glTexCoord2f(float s, float t)

void glRotatef32(float angle, int32 x, int32 y, int32 z)

void glMaterialf(GL_MATERIALS_ENUM mode, rgb color);
*/
#endif

